﻿using System;
using SqlSugar;
using Infrastructure.Attribute;
using ZR.Model;
using ZR.Model.Dto;
using ZR.Model.Models;
using ZR.Repository;
using ZR.Service.Business.IBusinessService;
using System.Linq;

namespace ZR.Service.Business
{
    /// <summary>
    /// 接口管理/SAP交验单记录表Service业务层处理
    ///
    /// @author admin
    /// @date 2023-05-05
    /// </summary>
    [AppService(ServiceType = typeof(ISapDeliverRecordService), ServiceLifetime = LifeTime.Transient)]
    public class SapDeliverRecordService : BaseService<SapDeliverRecord>, ISapDeliverRecordService
    {
        #region 业务逻辑代码

        /// <summary>
        /// 查询接口管理/SAP交验单记录表列表
        /// </summary>
        /// <param name="parm"></param>
        /// <returns></returns>
        public PagedInfo<SapDeliverRecordDto> GetList(SapDeliverRecordQueryDto parm)
        {
            //开始拼装查询条件
            var predicate = Expressionable.Create<SapDeliverRecord>();

            //搜索条件查询语法参考Sqlsugar
            var response = Queryable()
                .Where(predicate.ToExpression())
                .ToPage<SapDeliverRecord, SapDeliverRecordDto>(parm);

            return response;
        }


        /// <summary>
        /// 添加接口管理/SAP交验单记录表
        /// </summary>
        /// <param name="model"></param>
        /// <returns></returns>
        public int AddSapDeliverRecord(SapDeliverRecord model)
        {
            return Add(model, true);
        }

        /// <summary>
        /// 修改接口管理/SAP交验单记录表
        /// </summary>
        /// <param name="model"></param>
        /// <returns></returns>
        public int UpdateSapDeliverRecord(SapDeliverRecord model)
        {
            //var response = Update(w => w.Id == model.Id, it => new SapDeliverRecord()
            //{
            //    DeliverNo = model.DeliverNo,
            //    CheckName = model.CheckName,
            //    BomNo = model.BomNo,
            //    RowNo = model.RowNo,
            //    Category = model.Category,
            //    MaterialCode = model.MaterialCode,
            //    MaterialName = model.MaterialName,
            //    MaterialSpec = model.MaterialSpec,
            //    KeyFlag = model.KeyFlag,
            //    Qty = model.Qty,
            //    SpotCheckQty = model.SpotCheckQty,
            //    CheckQty = model.CheckQty,
            //    CheckResult = model.CheckResult,
            //    InstoreQty = model.InstoreQty,
            //    InstoreResult = model.InstoreResult,
            //    UpdateBy = model.UpdateBy,
            //    UpdateTime = model.UpdateTime,
            //    Remark = model.Remark,
            //});
            //return response;
            return Update(model, true);
        }

        /// <summary>
        /// 清空接口管理/SAP交验单记录表
        /// </summary>
        /// <returns></returns>
        public void TruncateSapDeliverRecord()
        {
            Truncate();
        }
        #endregion
    }
}